import java.util.Scanner;
import java.awt.Point;

/** Interfaz por consola de creacion y manipulacion de figuras 2D.*/

public class TestFigura
{
/** Figura que se crea y manipula.*/
	private static Figura miFigura;

/** Pasos a seguir en el test.*/

	public void testFigura ()
	{
		miFigura = new Figura ();
		System.out.println ("Bienvenido a TestFigura.\nSeleccione las formas que desee agregar a la figura:");
		miFigura = (Figura)figuraFactory();
		manipularForma (miFigura);
	}
	
/** Rutina de opciones para la creacion de figuras.*/
	
	public Forma figuraFactory ()
	{
		Scanner s = new Scanner (System.in);
		int opcion;
		do
		{
			System.out.println ("\n1: Crear Rectangulo.\n2: Crear Circulo.\n3: Salir.\nSeleccione su opcion:");
			opcion = 0;
			do
			{
				while(!s.hasNextInt())
				{	
					s.nextLine();
					System.out.println ("Ingrese una opcion valida, por favor:");
      		}
				opcion = s.nextInt();
				if ((opcion < 1) || (opcion > 3))
					System.out.println ("Ingrese una opcion valida, por favor:");
			} while ((opcion < 1) || (opcion > 3));
			if (opcion == 1)
				crearRectangulo();
			if (opcion == 2)
				crearCirculo();
		} while (opcion != 3);
		return miFigura;
	}

/** Rutina de creacion de Rectangulos. Se pide ingresar las coordenadas de las esquinas por consola.*/

	private void crearRectangulo ()
	{
		Scanner s = new Scanner (System.in);
		System.out.print ("\nIngrese las coordenadas de las esquinas del Rectangulo.\nx1:");
		int x1;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		x1 = s.nextInt();
		System.out.print ("y1:");
		int y1;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		y1 = s.nextInt();
		System.out.print ("x2:");
		int x2;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		x2 = s.nextInt();
		System.out.print ("y2:");
		int y2;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		y2 = s.nextInt();
		Point a = new Point (x1, y1);
		Point b = new Point (x2, y2);
		miFigura.addRectangulo(a, b);
		System.out.println ("Se ha creado un Rectangulo! Desea agregar otra figura?");
	}

/** Rutina de creacion de Circulos. Se pide ingresar el centro y el radio por consola.*/

	private void crearCirculo ()
	{
		Scanner s = new Scanner (System.in);
		System.out.print ("\nIngrese las coordenadas del centro del Circulo.\nx:");
		int x;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		x = s.nextInt();
		System.out.print ("y:");
		int y;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		y = s.nextInt();
		System.out.print ("Ingrese el radio del Circulo:");
		double r;
		while(!s.hasNextDouble())
		{	
			s.nextLine();
			System.out.print ("Ingrese un real, por favor;");
 		}
		r = s.nextDouble();
		Point c = new Point (x, y);
		miFigura.addCirculo (c, r);
		System.out.println ("Se ha creado un circulo! Desea agregar otra figura?");
	}
	
/** Rutina de opciones para manipular la figura.*/
	
	public void manipularForma (Forma f)
	{
		Scanner s = new Scanner (System.in);
		System.out.print ("\nSeleccione las modificaciones que quiere ejecutar sobre la figura:\n");
		int opcion;
		do
		{
			System.out.println ("1: Rotar.\n2: Trasladar.\n3: Escalar.\n4: Salir.\nSeleccione su opcion:");
			opcion = 0;
			do
			{
				while(!s.hasNextInt())
				{	
					s.nextLine();
					System.out.println ("Ingrese una opcion valida, por favor:");
      		}
				opcion = s.nextInt();
				if ((opcion < 1) || (opcion > 4))
					System.out.println ("Ingrese una opcion valida, por favor:");
			} while ((opcion < 1) || (opcion > 4));
			if (opcion == 1)
				rotarFigura(f);
			if (opcion == 2)
				trasladarFigura(f);
			if (opcion == 3)
				escalarFigura(f);
		} while (opcion != 4);
	}
	
/** Rutina de rotacion de la figura. Se pide ingresar el punto de rotacion y el angulo por consola. Se despliega el resultado en el mismo modo.*/
	
	public void rotarFigura (Forma f)
	{
		Scanner s = new Scanner (System.in);
		System.out.print ("Ingrese las coordenadas del punto de rotacion.\nx:");
		int x;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		x = s.nextInt();
		System.out.print ("y:");
		int y;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		y = s.nextInt();
		System.out.print ("Ingrese el angulo de rotacion:");
		double deltaAngulo;
		while(!s.hasNextDouble())
		{	
			s.nextLine();
			System.out.print ("Ingrese un real, por favor;");
 		}
		deltaAngulo = s.nextFloat();
		Point centro = new Point (x, y);
		f.rotar(centro, Math.toRadians(deltaAngulo));
		System.out.print ("Se ha rotado la figura, respecto a (" + x + ", " + y + "), en " + deltaAngulo + " grados.");
		System.out.print ("\nEl estado actual de la figura es:\n");
		miFigura.printFigura();
		System.out.print ("Desea realizar otra modificacion?\n");
	}
	
/** Rutina de traslacion de la figura. Se pide ingresar el desplazamiento por consola. Se despliega el resultado en el mismo modo.*/
	
	public void trasladarFigura (Forma f)
	{
		Scanner s = new Scanner (System.in);
		System.out.print ("\nIngrese ingrese el desplazamiento en el eje x:");
		double deltaX;
		while(!s.hasNextDouble())
		{	
			s.nextLine();
			System.out.print ("Ingrese un real, por favor;");
 		}
		deltaX = s.nextDouble();
		System.out.print ("Ingrese el desplazamiento en el eje y:");
		double deltaY;
		while(!s.hasNextDouble())
		{	
			s.nextLine();
			System.out.print ("Ingrese un real, por favor;");
 		}
		deltaY = s.nextDouble();
		f.trasladar(deltaX, deltaY);
		System.out.print ("Se ha trasladado la figura, en sentido " + deltaX + ", " + deltaY + ".");
		System.out.print ("\nEl estado actual de la figura es:\n");
		miFigura.printFigura();
		System.out.print ("Desea realizar otra modificacion?\n");
	}

/** Rutina de escalamiento de la figura. Se pide ingresar el punto de referencia y el factor por consola. Se despliega el resultado en el mismo modo.*/
	
	public void escalarFigura (Forma f)
	{
		Scanner s = new Scanner (System.in);
		System.out.print ("\nIngrese las coordenadas del punto de escalamiento.\nx:");
		int x;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		x = s.nextInt();
		System.out.print ("y:");
		int y;
		while(!s.hasNextInt())
		{	
			s.nextLine();
			System.out.print ("Ingrese un entero, por favor;");
 		}
		y = s.nextInt();
		System.out.print ("Ingrese el factor de escalamiento:");
		double factor;
		while(!s.hasNextDouble())
		{	
			s.nextLine();
			System.out.print ("Ingrese un real, por favor;");
 		}
		factor = s.nextDouble();
		Point centro = new Point (x, y);
		f.escalar(centro, factor);
		System.out.print ("Se ha escalado la figura, respecto a (" + x + ", " + y + "), en un factor de" + factor + ".");
		System.out.print ("\nEl estado actual de la figura es:\n");
		miFigura.printFigura();
		System.out.print ("Desea realizar otra modificacion?\n");
	}
}